
/******************************************************************************
* MODULE     : word.gen.h
* DESCRIPTION: abstract power word
* COPYRIGHT  : (C) 1999  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef WORD_HH
#define WORD_HH
#include "array.hh"
#include "hashmap.hh"

// WARNING: word_rep is a symbol private to refcounting macros!
#define word_rep array_rep
template<class G> class word : public array {
  CONCRETE_TEMPLATE(word,G);
  inline word (int n=0): array(n) {}
  inline word (T *a, int n): array(a, n) {}
  static array<word<G> > homogeneous (int d);
};
CONCRETE_TEMPLATE_CODE(word,class,G);
#undef word_rep

#define TMPL template<class G>
TMPL word<G> operator * (word<G> u, word<G> v);
TMPL int hash (word<G> w);
#undef TMPL

#endif // defined WORD_HH
